unit MannAnsi;

interface

uses
    Classes, Crt, SysUtils;

const
     COLOURS: Array[0..7] of Integer = (0, 4, 2, 6, 1, 5, 3, 7);

procedure aWrite(S: String);
procedure aWriteLn(S: String);
procedure aDisplayFile(S: String);

implementation

var
   Num: Array[1..8] of Integer;
   SaveX, SaveY: Integer;
   GotBracket: Boolean;
   GotESC: Boolean;
   Str: String;

procedure GetNum(S: String);
var
   Str: String;
   I, J: Integer;
begin
     for I := Low(Num) to High(Num) do
         Num[I] := -1;

     J := 1;
     Str := '';

     for I := 1 to Length(S) do
     begin
          if (S[I] in ['0'..'9']) then
             Str := Str + S[I]
          else
          if (S[I] = ';') then
          begin
               Num[J] := StrToInt(Str);
               Str := '';
               Inc(J);
          end;
     end;
     if (Str <> '') then
        Num[J] := StrToInt(Str);
end;

procedure ParseCommand(Cmd: Char);
var
   I: Integer;
   Colour: Integer;
begin
     case Cmd of
     'H', 'f': begin
                    if (Num[1] = -1) then
                       Num[1] := 1;
                    if (Num[2] = -1) then
                       Num[2] := 1;
                    GotoXY(Num[2], Num[1]);
               end;
          'A': begin
                    if (Num[1] = -1) then
                       Num[1] := 1;
                    repeat
                          Dec(Num[1]);
                          GotoXY(WhereX, WhereY - 1);
                    until (Num[1] = 0);
               end;
          'B': begin
                    if (Num[1] = -1) then
                       Num[1] := 1;
                    repeat
                          Dec(Num[1]);
                          GotoXY(WhereX, WhereY + 1);
                    until (Num[1] = 0);
               end;
          'C': begin
                    if (Num[1] = -1) then
                       Num[1] := 1;
                    repeat
                          Dec(Num[1]);
                          GotoXY(WhereX + 1, WhereY);
                    until (Num[1] = 0);
               end;
          'D': begin
                    if (Num[1] = -1) then
                       Num[1] := 1;
                    repeat
                          Dec(Num[1]);
                          GotoXY(WhereX - 1, WhereY);
                    until (Num[1] = 0);
               end;
          's': begin
                    SaveX := WhereX;
                    SaveY := WhereY;
               end;
          'u': begin
                    GotoXY(SaveX, SaveY);
               end;
          'J': begin
                    if (Num[1] = 2) then
                       ClrScr;
               end;
          'K': begin
                    ClrEol;
               end;
          'm': begin
                    if (Num[1] = -1) then
                       Num[1] := 0;
                    I := 1;
                    repeat
                          case Num[I] of
                               0: begin
                                       TextAttr := 7;
                                  end;
                               1: begin
                                       HighVideo;
                                  end;
                               4: begin
                                       {underscore}
                                  end;
                               5: begin
                                       {blink}
                                  end;
                               7: begin
                                       TextAttr := ((TextAttr and $07) shl 4) + ((TextAttr and $70) shr 4);
                                  end;
                               8: begin
                                       TextAttr := 0;
                                  end;
                          30..37: begin
                                       Colour := COLOURS[Num[I] - 30];
                                       if (TextAttr mod 16 > 7) then
                                          Inc(Colour, 8);
                                       TextColor(Colour);
                                  end;
                          40..47: begin
                                       TextBackground(COLOURS[Num[I] - 40]);
                                  end;
                          end;

                          Inc(I);
                    until (Num[I] = -1);
               end;
     end;
end;

procedure aWrite(S: String);
var
   I: Integer;
begin
     for I := 1 to Length(S) do
     begin
          if (S[I] = #27) then
             GotESC := True
          else
          if (S[I] = '[') and (GotESC) then
             GotBracket := True
          else
          if (GotESC) and (GotBracket) then
          begin
               if (Pos(S[I], 'HfABCDsuJKmhlp') <> 0) then
               begin
                    GetNum(Str);
                    ParseCommand(S[I]);
                    GotESC := False;
                    Str := '';
               end else
                   Str := Str + S[I];
          end else
              Write(S[I]);
     end;
end;

procedure aWriteLn(S: String);
begin
     aWrite(S + #13#10);
end;

procedure aDisplayFile(S: String);
var
   Sl: TStringList;
   I: Integer;
begin
     if (FileExists(S)) then
     begin
          Sl := TStringList.Create;
          Sl.LoadFromFile(S);
          if (Sl.Count = 1) then
             aWrite(Sl[0])
          else
          if (Sl.Count > 1) then
          begin
               for I := 0 to Sl.Count - 2 do
                   aWriteLn(Sl[I]);
               aWrite(Sl[Sl.Count - 1]);
          end;
          Sl.Free;
     end;
end;

begin
     TextAttr := 7;
     GotESC := False;
     GotBracket := False;
     SaveX := 1;
     SaveY := 1;
     Str := '';
end.
