procedure CheckDropCarrier;
begin
     if Not(mCarrier) and (Assigned(DropCarrierProc)) then
     begin
          mClose;
          DropCarrierProc;
          Delay(2500);
          Halt;
     end;
end;

procedure CheckStatusBar;
begin
     if (Assigned(StatusBarProc)) then
        StatusBarProc;
end;

procedure CheckTimeIdle(CurTime, LastKey: LongInt);
begin
     if (Assigned(TimeOutProc)) then
     begin
          mUserInfo.IdleTime := Elapsed(LastKey, CurTime);
          if (mUserInfo.IdleTime > mUserInfo.IdleMax) then
          begin
               TimeOutProc;
               mClose;
               Delay(2500);
               Halt;
          end;
     end;
end;

procedure CheckTimeLeft(CurTime: LongInt);
begin
     if (Assigned(TimeUpProc)) then
     begin
          mUserInfo.TimeLeft := mUserInfo.TimeMax - Elapsed(mUserInfo.TimeOn, CurTime);
          if (mUserInfo.TimeLeft < 1) then
          begin
               TimeUpProc;
               mClose;
               Delay(2500);
               Halt;
          end;
     end;
end;

procedure DoLocalLogin;
begin
     if (Assigned(LocalLoginProc)) then
        LocalLoginProc;
     ClrScr;
     if (mUserInfo.UserF = '') then
        mUserInfo.UserF := 'John';
     if (mUserInfo.UserL = '') then
        mUserInfo.UserL := 'Doe';
     if (mUserInfo.Handle = '') then
        mUserInfo.Handle := 'JohnDoe';
end;

procedure DefaultDropCarrierProc;
begin
     TextAttr := 15;
     ClrScr;
     WriteLn;
     WriteLn('   CALLER DROPPED CARRIER.  RETURNING TO BBS');
end;

procedure DefaultLocalLoginProc;
var
   S: String;
begin
     ClrScr;
     WriteLn;
     WriteLn('  LOCAL LOGON');
     WriteLn;
     repeat
           Write('  Enter your name : ');
           S := mInputLn('SYSOP', MASK_ALPHA, 41, 41, 31);
     until (S <> '');
     if (Pos(' ', S) = 0) then
     begin
          mUserInfo.UserF := S;
          mUserInfo.UserL := 'NLN';
          mUserInfo.Handle := S;
     end else
     begin
          mUserInfo.UserF := Copy(S, 1, Pos(' ', S) - 1);
          Delete(S, 1, Pos(' ', S));
          mUserInfo.UserL := S;
          mUserInfo.Handle := mUserInfo.UserF + mUserInfo.UserL;
     end;
end;

procedure DefaultStatusBarProc;
var
   Name, Caption, Idle, Time: String;
begin
     FastWrite(PadRight('', ' ', 80), 1, 25, 31);
     FastWrite(mUserInfo.UserF + ' ' + mUserInfo.UserL, 1, 25, 31);
     FastWrite('   A MannDoor Door', 25, 25, 31);
     FastWrite('IDLE: ' + IntToStr(mUserInfo.IdleTime) + 's', 54, 25, 31);
     FastWrite('TIME: ' + SecToHMS(mUserInfo.TimeLeft), 66, 25, 31);
end;

procedure DefaultTimeOutProc;
begin
     mTextColor(15);
     mTextBackground(0);
     mClrScr;
     mCrlf;
     mWriteLn('  IDLE TIME LIMIT EXCEEDED.  RETURNING TO BBS');
end;

procedure DefaultTimeUpProc;
begin
     mTextColor(15);
     mTextBackground(0);
     mClrScr;
     mCrlf;
     mWriteLn('  YOUR TIME HAS EXPIRED.  RETURNING TO BBS');
end;
