unit mConnect;

interface

uses
    Classes, MannDoor, SockDef, SockFunc, SysUtils,
    mGlobal;

function Connect(Address: String; Port: LongInt): Boolean;
procedure DoConnect(S: String);

implementation

function Connect(Address: String; Port: LongInt): Boolean;
var
   Host: PHostEnt;
   P: Pointer;
   Remote: TSockAddr;
   Remote_Addr: TIn_Addr;
begin
     Result := False;

     OutP('Connecting to ' + Address);

     New(Host);
     FillChar(Host^, SizeOf(Host^), 0);
     Host := SockGetHostByName(Address);
     if (Host = nil) then
     begin
          OutP('Unable to resolve address');
          Exit;
     end;

     FillChar(Remote, SizeOf(Remote), 0);
     Remote.Sin_Port := SockHToNS(Port);
     Remote.Sin_Family := PF_INET;
     P := Host^.H_Addr_List^;
     Move(P^, Remote_Addr, 4);
     Remote.Sin_Addr := Remote_Addr;

     Sock := SockSocket(AF_INET, SOCK_STREAM, 0);
     if (SockConnect(Sock, Remote) <> 0) then
        OutP('Unable to connect')
     else
     begin
          SockWriteLn('NICK ' + mUserInfo.Handle);
          SockWriteLn('USER ' + mUserInfo.Handle + ' localhost localhost :' + mUserInfo.UserF + ' ' + mUserInfo.UserL);
          Result := True;
     end;
end;

procedure DoConnect(S: String);
var
   I: Integer;
   Sl: TStringList;
begin
     IRCServer := '<none>';

     Sl := TStringList.Create;
     Ini.ReadSection(S, Sl);
     if (Sl.IndexOf('channels') <> -1) then
        Sl.Delete(Sl.IndexOf('channels'));
     if (Sl.Count = 0) then
        Exit;

     for I := 0 to Sl.Count - 1 do
     begin
          if (Connect(Sl[I], Ini.ReadInteger(S, Sl[I], 6667))) then
          begin
               DoJoin := True;
               IRCServer := S;
               Break;
          end;
     end;


     Sl.Free;
end;

initialization

finalization

end.
