unit mMsg;

interface

uses
    Classes, MannDoor, MannUtls, SysUtils,
    mGlobal;

procedure HandleMessage(S: String);

implementation

procedure HandleAction; forward;
procedure HandleCTCPReply; forward;
procedure HandleCTCPRequest; forward;
procedure HandleJoin; forward;
procedure HandleKick; forward;
procedure HandleNick; forward;
procedure HandleNotice; forward;
procedure HandlePart; forward;
procedure HandlePrivmsg; forward;
procedure HandleQuit; forward;

var
   Sl: TStringList;

procedure HandleAction;
var
   S: String;
begin
     S := JoinS(Sl, 4);
     Delete(S, Length(S), 1);
     Out('8 E' + GetNick(Sl[0]) + '8:E' + Sl[2] + ' 7' + S);
end;

procedure HandleCTCPReply;
var
   S: String;
   S2: String;
begin
     S := Strip(Sl[3]);
     Delete(S, 1, 1);
     if (S[Length(S)] = #1) then
        Delete(S, Length(S), 1);

     if (S = 'PING') then
     begin
          S := JoinS(Sl, 4);
          Delete(S, Length(S), 1);
          OutP('CTCP FPING 7reply from ' + GetNick(Sl[0]) + ': ' + SecToDHMS(Elapsed(StrToIntDef(S, SecondsSinceMidnight), SecondsSinceMidnight)));
     end else
     begin
          S2 := JoinS(Sl, 4);
          if (S2 <> '') then
             if (S2[Length(S2)] = #1) then
                Delete(S2, Length(S2), 1);
          OutP('CTCP F' + UpperCase(S) + ' 7reply from ' + GetNick(Sl[0]) + ': ' + S2);
     end;
end;

procedure HandleCTCPRequest;
var
   S: String;
   S2: String;
begin
     S := Strip(Sl[3]);
     Delete(S, 1, 1);
     if (S[Length(S)] = #1) then
        Delete(S, Length(S), 1);

     S2 := JoinS(Sl, 3);
     Delete(S2, 1, 1);
     Delete(S2, Length(S2), 1);

     if (S <> 'ACTION') then
        OutP('A' + GetNick(Sl[0]) + ' 2requested ' + S2);

     if (S = 'ACTION') then
        HandleAction
     else
     if (Elapsed(LastCTCP, SecondsSinceMidnight) > Ini.ReadInteger('general', 'ctcpdelay', 10)) then
     begin
          if (S = 'PING') then
          begin
               S := Sl[4];
               Delete(S, Length(S), 1);
               SockWriteLn('NOTICE ' + GetNick(Sl[0]) + ' :' + #1 + 'PING ' + S + #1);
          end else
          if (S = 'VERSION') then
             SockWriteLn('NOTICE ' + GetNick(Sl[0]) + ' :' + #1 + 'VERSION ' + Copyright + #1)
          else
          if (S = 'TIME') then
             SockWriteLn('NOTICE ' + GetNick(Sl[0]) + ' :' + #1 + 'TIME ' + DateTimeToStr(Now) + #1);

          LastCTCP := SecondsSinceMidnight;
     end;
end;

procedure HandleJoin;
begin
     Sl[2] := Strip(Sl[2]);
     if (UpperCase(GetNick(Sl[0])) = UpperCase(mUserInfo.Handle)) then
     begin
          ChanList.Add(Sl[2]);
          CurChan := ChanList.IndexOf(Sl[2]);
     end;
     OutP('B' + GetNick(Sl[0]) + ' 8[3' + GetAddress(Sl[0]) + '8] 7has joined ' + Sl[2]);
end;

procedure HandleKick;
begin
     if (UpperCase(Sl[3]) = UpperCase(mUserInfo.Handle)) then
     begin
          if (ChanList.IndexOf(Sl[2]) = CurChan) then
          begin
               ChanList.Delete(ChanList.IndexOf(Sl[2]));
               CycleChannel;
          end else
              ChanList.Delete(ChanList.IndexOf(Sl[2]));
     end;
     OutP(Sl[3] + ' was kicked off ' + Sl[2] + ' by 3' + GetNick(Sl[0]) + ' 8(7' + JoinS(Sl, 4) + '8)');
end;

procedure HandleMessage(S: String);
var
   I: Integer;
   Num: Integer;
begin
     BreakUp(S, Sl);

     Num := StrToIntDef(Sl[1], -1);

     case Num of
          001: //UNKNOWN
               OutP(JoinS(Sl, 3));
          002: //UNKNOWN
               OutP(JoinS(Sl, 3));
          003: //UNKNOWN
               OutP(JoinS(Sl, 3));
          004: //UNKNOWN
               OutP(JoinS(Sl, 3));
          005: //UNKNOWN
               OutP(JoinS(Sl, 3));

          200..206, 208, 261: //RPL_TRACE*
               Out('7' + Join(Sl, 0));
          211..219, 241..244: //RPL_STATS*
               Out('7' + Join(Sl, 0));
          221: //RPL_UMODEIS "<user mode string>"
               OutP('Your user mode is [' + Sl[3] + ']');
          250: //UNKNOWN
               OutP(JoinS(Sl, 3));
          251: //RPL_LUSERCLIENT ":There are <integer> users and <integer> invisible on <integer> servers"
               OutP(JoinS(Sl, 3));
          252: //RPL_LUSEROP "<integer> :operator(s) online"
               OutP('Operator(s) online: ' + Sl[3]);
          253: //RPL_LUSERUNKNOWN "<integer> :unknown connection(s)"
               OutP('Unknown connection(s): ' + Sl[3]);
          254: //RPL_LUSERCHANNELS "<integer> :channels formed"
               OutP('Channel(s) formed: ' + Sl[3]);
          255: //RPL_LUSERME ":I have <integer> clients and <integer> servers"
               OutP(JoinS(Sl, 3));
          256: //RPL_ADMINME "<server> :Administrative info"
               OutP(JoinS(Sl, 3));
          257: //RPL_ADMINLOC1 ":<admin info>"
               OutP(JoinS(Sl, 3));
          258: //RPL_ADMINLOC2 ":<admin info>"
               OutP(JoinS(Sl, 3));
          259: //RPL_ADMINEMAIL ":<admin info>"
               OutP(JoinS(Sl, 3));
          260: //RPL_ADMINACTIVE ":<admin> is currently active"
               OutP(JoinS(Sl, 3));
          265: //RPL_LOCUSERS ":Current local users: <integer>  Max: <integer>"
               OutP(JoinS(Sl, 3));
          266: //RPL_GLOBUSERS ":Current global users: <integer>  Max: <integer>"
               OutP(JoinS(Sl, 3));

          300: //RPL_NONE
               ;
          301: //RPL_AWAY "<nick> :<away message>"
               Out('8| Fa7way     : ' + Sl[3] + ' - ' + JoinS(Sl, 4));
          302: //RPL_USERHOST ":[<reply>{<space><reply>}]"
               ;
          303: //RPL_ISON ":[<nick> {<space><nick>}]"
               OutP('Currently online: ' + JoinS(Sl, 3));
          305: //RPL_UNAWAY ":You are no longer marked as being away"
               OutP(JoinS(Sl, 3));
          306: //RPL_NOWAWAY ":You have been marked as being away"
               OutP(JoinS(Sl, 3));
          311: //RPL_WHOISUSER "<nick> <user> <host> * :<real name>"
               begin
                    Out('A---2A--2A-2---82--82-8--- --  -');
                    Out('A| F' + Sl[3] + ' 8(7' + Sl[4] + '@' + Sl[5] + '8)');
                    Out('A Fi7rcname  : ' + JoinS(Sl, 7));
               end;
          312: //RPL_WHOISSERVER "<nick> <server> :<server info>"
               Out('8 Fs7erver   : ' + Sl[4] + ' 8(7' + JoinS(Sl, 5) + '8)');
          313: //RPL_WHOISOPERATOR "<nick> :is an IRC operator"
               Out('8| Fo7ther    : ' + Sl[3] + ' ' + JoinS(Sl, 4));
          314: //RPL_WHOWASUSER "<nick> <user> <host> * :<real name>"
               begin
                    OutP('F' + Sl[3] + '7 was 8(7' + Sl[4] + '@' + Sl[5] + '8)');
                    OutP('Fi7rcname  : ' + JoinS(Sl, 7));
               end;
          315: //RPL_ENDOFWHO "<name> :End of /WHO list"
               ;
          317: //RPL_WHOISIDLE "<nick> <integer> :seconds idle"
               Out('8: Fi7dle     : ' + SecToDHMS(StrToIntDef(Sl[4], 0)));
          318: //RPL_ENDOFWHOIS "<nick> :End of /WHOIS list"
               ;
          319: //RPL_WHOISCHANNELS "<nick> :{[@|+]<channel><space>}"
               Out('8| Fc7hannels : ' + JoinS(Sl, 4));
          321: //RPL_LISTSTART "Channel :Users  Name"
               Out(PadRight('Channel', ' ', 10) + '  ' + PadRight('Users', ' ', 5) + '  ' + PadRight('Topic', ' ', 60));
          322: //RPL_LIST "<channel> <# visible> :<topic>"
               Out(PadRight(Sl[3], ' ', 10) + '  ' + PadLeft(Sl[4], ' ', 5) + '  ' + PadRight(JoinS(Sl, 5), ' ', 60));
          323: //RPL_LISTEND ":End of /LIST"
               ;
          324: //RPL_CHANNELMODEIS "<channel> <mode> :<mode params>"
               begin
               OutP(JoinS(Sl, 0));
                    if (Sl.Count = 5) then
                       OutP('mode8/3' + Sl[3] + ' 8[F' + Sl[4] + '8]')
                    else
                        OutP('mode8/3' + Sl[3] + ' 8[F' + Sl[4] + ' ' + JoinS(Sl, 5) + '8]');
               end;
          329: //RPL_CHANNELCREATEDON "<channel> <integer>"
               OutP('Channel ' + Sl[3] + ' was created at ' + DateTimeToStr(UnixTimeToDateTime(StrToFloat(Sl[4]))));
          331: //RPL_NOTOPIC "<channel> :No topic is set"
               ;
          332: //RPL_TOPIC "<channel> :<topic>"
               OutP('Topic 8(3' + Sl[3] + '8): 7' + JoinS(Sl, 4));
          333: //RPL_TOPICSETDATE "<channel> <setter> <integer>"
               OutP('Topic 8(3' + Sl[3] + '8): 7set by 3' + Sl[4] + ' 7at 3' + DateTimeToStr(UnixTimeToDateTime(StrToFloat(Sl[5]))));
          341: //RPL_INVITING "<channel> <nick>"
               OutP('FInviting ' + Sl[4] + ' to ' + Sl[3]);
          342: //RPL_SUMMONING "<user> :Summoning user to IRC"
               ;
          351: //RPL_VERSION "<version>.<debuglevel> <server> :<comments>"
               OutP(JoinS(Sl, 3));
          352: //RPL_WHOREPLY "<channel> <user> <host> <server> <nick> <H|G>[*][@|+] :<hopcount> <real name>"
               OutP(Sl[3] + ' ' + Sl[7] + ' ' + Sl[8] + ' ' + Sl[4] + '@' + Sl[5] + ' ' + JoinS(Sl, 8));
          353: //RPL_NAMESREPLY "= <channel> :[[@|+]<nick> [[@|+]<nick> [...]]]"
               begin
                    OutP('8[AUsers8(2' + Sl[4] + '8:2' + IntToStr(Sl.Count - 5) + '8)]');
                    S := '';
                    for I := 5 to Sl.Count - 1 do
                        S := S + '8[9' + PadRight(Strip(Sl[I]), ' ', 13)+ '8] ';
                    Out(S);
               end;
          364: //todo //RPL_LINKS "<mask> <server> :<hopcount> <server info>"
               OutP(Sl[4] + ' ' + JoinS(Sl, 5));
          365: //RPL_ENDOFLINKS "<mask> :End of /LINKS list"
               ;
          366: //RPL_ENDOFNAMES "<channel> :End of /NAMES list"
               ;
          367: //todo //RPL_BANLIST "<channel> <banid>"
               OutP(Sl[3] + ' ' + Sl[4]);
          368: //RPL_ENDOFBANLIST "<channel> :End of channel ban list"
               ;
          369: //RPL_ENDOFWHOWAS "<nick> :End of WHOWAS"
               ;
          371: //RPL_INFO ":<string>"
               OutP(JoinS(Sl, 3));
          372: //RPL_MOTD ":- <text>"
               if (ShowMOTD) then
                  OutP(JoinS(Sl, 3));
          374: //RPL_ENDOFINFO ":End of /INFO list"
               ;
          375: //RPL_MOTDSTART ":- <server> Message of the day - "
               if (ShowMOTD) then
                  OutP(JoinS(Sl, 3));
          376: //RPL_ENDOFMOTD ":End of /MOTD command"
               begin
                    ShowMOTD := False;
                    if (DoJoin) then
                    begin
                         DoJoin := False;
                         if (Ini.ReadString(IRCServer, 'channels', '') <> '') then
                            SockWriteLn('JOIN ' + Ini.ReadString(IRCServer, 'channels', ''));
                    end;
               end;
          381: //RPL_YYOUREOPER ":You are now an IRC operator"
               OutP(JoinS(Sl, 3));
          382: //RPL_REHASHING "<config file> :Rehashing"
               OutP(JoinS(Sl, 4) + Sl[3]);
          391: //RPL_TIME "<server> :<string showing server's local time>"
               OutP(Sl[3] + JoinS(Sl, 4));
          392..395: //RPL_USERS*
               Out('7' + Join(Sl, 0));

          401: //ERR_NOSUCHNICK "<nickname> :No such nick/channel"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          402: //ERR_NOSUCHSERVER "<server name> :No such server"
               OutP(Sl[3] + '  ' + JoinS(Sl, 4));
          403: //ERR_NOSUCHCHANNEL "<channel name> :No such channel"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          404: //ERR_CANNOTSENDTOCHAN "<channel name> :Cannot send to channel"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          405: //ERR_TOOMANYCHANNELS "<channel name> :You have joined too many channels"
               OutP(JoinS(Sl, 4));
          406: //ERR_WASNOSUCHNICK "<nickname> :There was no such nickname"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          407: //ERR_TOOMANYTARGETS "<target> :Duplicate recipients.  No message sent"
               OutP(JoinS(Sl, 4));
          409: //ERR_NOORIGIN ":No origin specified"
               OutP(JoinS(Sl, 3));
          411: //ERR_NORECIPIENT ":No recipient given"
               OutP(JoinS(Sl, 3));
          412: //ERR_NOTEXTTOSEND ":No text to send"
               OutP(JoinS(Sl, 3));
          413: //ERR_NOTOPLEVEL "<mask> :No toplevel domain specified"
               OutP(JoinS(Sl, 4));
          414: //ERR_WILDTOPLEVEL "<mask> :Wildcard in toplevel domain"
               OutP(JoinS(Sl, 4));
          421: //ERR_UNKNOWNCOMMAND "<command> :Unknown command"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          422: //ERR_NOMOTD ":MOTD File is missing"
               OutP(JoinS(Sl, 3));
          423: //ERR_NOADMININFO "<server> :No administrative info available"
               OutP(JoinS(Sl, 4));
          424: //ERR_FILEERROR ":File error doing <file op> on <file>"
               OutP(JoinS(Sl, 3));
          431: //ERR_NONICKNAMEGIVEN ":No nickname given"
               OutP(JoinS(Sl, 3));
          432: //ERR_ERRONEUSNICKNAME "<nick> :Erroneus nickname"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          433: //ERR_NICKNAMEINUSE "<nick> :Nickname is already in use"
               begin
                    OutP(JoinS(Sl, 4) + '.  Appending _');
                    mUserInfo.Handle := Sl[3] + '_';
                    SockWriteLn('NICK ' + mUserInfo.Handle);
               end;
          436: //ERR_NICKCOLLISION "<nick> :Nickname collision KILL"
               OutP(JoinS(Sl, 4));
          441: //ERR_USERNOTINCHANNEL "<nick> <channel> :They aren't on that channel"
               OutP(Sl[3] + ' is not on ' + Sl[4]);
          442: //ERR_NOTONCHANNEL "<channel> :You're not on that channel"
               OutP('You''re not on ' + Sl[3]);
          443: //ERR_USERONCHANNEL "<user> <channel> :is already on channel"
               OutP(Sl[3] + ' is already on ' + Sl[4]);
          444: //ERR_NOLOGIN "<user> :User not logged in"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          445: //ERR_SUMMONDISABLED ":SUMMON has been disabled"
               OutP(JoinS(Sl, 3));
          446: //ERR_USERSDISABLED ":USeRS has been disabled"
               OutP(JoinS(Sl, 3));
          451: //ERR_NOTREGISTERED ":You have not registered"
               OutP(JoinS(Sl, 3));
          461: //ERR_NEEDSMOREPARAMS "<command> :Not enough parameters"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          462: //ERR_ALREADYREGISTERED ":You may not reregister"
               OutP(JoinS(Sl, 3));
          463: //ERR_NOPERMFORHOST ":Your host isnt among the priveledged"
               OutP(JoinS(Sl, 3));
          464: //ERR_PASSWDMISMATCH ":Password incorrect"
               OutP(JoinS(Sl, 3));
          465: //ERR_YOUREBANNEDCREEP ":You are banned from this server"
               OutP(JoinS(Sl, 3));
          467: //ERR_KEYSET "<channel> :Channel key already set"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          471: //ERR_CHANNELISFULL "<channel> :Cannot join channel (+l)"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          472: //ERR_UNKNOWNMODE "<char> :is unknown mode char to me"
               OutP(Sl[3] + ' ' + JoinS(Sl, 4));
          473: //ERR_INVITEONLYCHAN "<channel> :Cannot join channel (+i)"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          474: //ERR_BANNEDFROMCHAN "<channel> :Cannot join channel (+b)"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          475: //ERR_BADCHANNELKEY "<channel> :Cannot join channel (+k)"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          481: //ERR_NOPRIVELEGES ":Permission Denied- You're not an IRC operator"
               OutP(JoinS(Sl, 3));
          482: //ERR_CHANOPRIVSNEEDED "<channel> :You're not a channel operator"
               OutP(JoinS(Sl, 4) + ': ' + Sl[3]);
          483: //ERR_CANTKILLSERVER ":You cant kill a server!"
               OutP(JoinS(Sl, 3));
          491: //ERR_NOOPERHOST ":No O-lines for your host"
               OutP(JoinS(Sl, 3));

          501: //ERR_UMODEUNKNOWNFLAG ":Unknown MODE flag"
               OutP(JoinS(Sl, 3));
          502: //ERR_USERSDONTMATCH ":Cant change mode for other users"
               OutP(JoinS(Sl, 3));
          else
              if (Num <> -1) then
                 Out('8' + S);
     end;

     if (Num = -1) then
     begin
          if (Sl[0] = 'ERROR') then
             Out('8ERROR: ' + JoinS(Sl, 1))
          else
          if (Sl[1] = 'INVITE') then
             OutP('F' + GetNick(Sl[0]) + ' Invites You to ' + Strip(Sl[3]))
          else
          if (Sl[1] = 'JOIN') then
             HandleJoin
          else
          if (Sl[1] = 'KICK') then
             HandleKick
          else
//:Z!michael@cx2002598-b.omhan1.ne.home.com KILL Manning_ :cx2002598-b.omhan1.ne.home.com!Z (just a test of the emergency "mannings working on mannirc" system.)
//          if (Sl[1] = 'KILL') then
//             HandleKill
          if (Sl[1] = 'MODE') then
             OutP('Mode' + '8/3' + Sl[2] + ' 8[F' + JoinS(Sl, 3) + '8] 7by F' + GetNick(Sl[0]))
          else
          if (Sl[1] = 'NICK') then
             HandleNick
          else
          if (Sl[0] = 'NOTICE') then
             OutP(JoinS(Sl, 2))
          else
          if (Sl[1] = 'NOTICE') then
             HandleNotice
          else
          if (Sl[1] = 'PART') then
             HandlePart
          else
          if (Sl[0] = 'PING') then
             SockWriteLn('PONG ' + Sl[1])
          else
          if (Sl[1] = 'PRIVMSG') then
             HandlePrivmsg
          else
          if (Sl[1] = 'QUIT') then
             HandleQuit
          else
          if (Sl[1] = 'TOPIC') then
             OutP('Topic 8(3' + Sl[2] + '8): 7changed by 3' + GetNick(Sl[0]) + '8: 7' + JoinS(Sl, 3))
          else
              Out('8' + S);
     end;
end;

procedure HandleNick;
begin
     Sl[2] := Strip(Sl[2]);
     if (UpperCase(GetNick(Sl[0])) = UpperCase(mUserInfo.Handle)) then
     begin
          OutP('You are now known as ' + Sl[2]);
          mUserInfo.Handle := Sl[2];
     end else
         OutP('F' + GetNick(Sl[0]) + ' 7is now known as 3' + Sl[2]);
end;

procedure HandleNotice;
begin
     if (Sl[3][2] = #1) then
        HandleCTCPReply
     else
     begin
          if (UpperCase(Sl[2]) = UpperCase(mUserInfo.Handle)) then
             Out('8-D' + GetNick(Sl[0]) + '8(5' + GetAddress(Sl[0]) + '8)- 7' + JoinS(Sl, 3))
          else
              Out('8-D' + GetNick(Sl[0]) + '8:5' + Sl[2] + '8- 7' + JoinS(Sl, 3));
     end;

end;

procedure HandlePart;
begin
     Sl[2] := Strip(Sl[2]);
     if (UpperCase(GetNick(Sl[0])) = UpperCase(mUserInfo.Handle)) then
     begin
          if (ChanList.IndexOf(Sl[2]) = CurChan) then
          begin
               ChanList.Delete(ChanList.IndexOf(Sl[2]));
               CycleChannel;
          end else
          if (ChanList.IndexOf(Sl[2]) < CurChan) then
          begin
               ChanList.Delete(ChanList.IndexOf(Sl[2]));
               Dec(CurChan);
          end else
              ChanList.Delete(ChanList.IndexOf(Sl[2]));
     end;
     OutP('B' + GetNick(Sl[0]) + ' 8[3' + GetAddress(Sl[0]) + '8] 7has left ' + Sl[2]);
end;

procedure HandlePrivmsg;
begin
     if (Sl[3][2] = #1) then
        HandleCTCPRequest
     else
     begin
          if (UpperCase(Sl[2]) = UpperCase(mUserInfo.Handle)) then
             Out('8[D' + GetNick(Sl[0]) + '8(5' + GetAddress(Sl[0]) + '8)] 7' + JoinS(Sl, 3))
          else
              Out('9<7' + GetNick(Sl[0]) + '8:7' + Sl[2] + '9> 7' + JoinS(Sl, 3));
     end;
end;

procedure HandleQuit;
begin
     OutP('SignOff F' + GetNick(Sl[0]) + ' 8(7' + JoinS(Sl, 2) + '8)')
end;

initialization
begin
     Sl := TStringList.Create;
end;

finalization
begin
     Sl.Free;
end;

end.
