unit mThreads;

interface

uses
    MannDoor, SockFunc, vpSysLow, vpUtils,
    mCmd, mGlobal, mMsg;

var
   LocalBuf, RemoteBuf: String;
   PC: PChar;

procedure StartIOThread;

implementation

function IOThread(P: Pointer): LongInt;
var
   Ch: Char;
   S: String;
   NumRead: LongInt;
   Connected: Boolean;
begin
     Connected := False;
     repeat
           SysCtrlSleep(1);

{Server Stuff}
           if (SockDataAvail(Sock)) then
           begin
                NumRead := SockRecv(Sock, PC, 4096, 0);
                if (NumRead < 1) then
                begin
                     Disconnect;
                     RedrawInput;
                end else
                begin
                     PC[NumRead] := #0;
                     RemoteBuf := RemoteBuf + PC;

                     while (Pos(#13, RemoteBuf) > 0) do
                           Delete(RemoteBuf, Pos(#13, RemoteBuf), 1);
                     ClearInput;
                     while (Pos(#10, RemoteBuf) > 0) do
                     begin
                          HandleMessage(Copy(RemoteBuf, 1, Pos(#10, RemoteBuf) - 1));
                          Delete(RemoteBuf, 1, Pos(#10, RemoteBuf));
                     end;
                     RedrawInput;
                end;
           end;

{Client Stuff}
           if (mKeyPressed) then
           begin
                Ch := mReadKey;
                if (Ch = #0) then
                   mReadKey;

                if (Ch = ^X) then
                begin
                     if (CycleChannel) then
                        RedrawInput;
                end else
                if (Ch = #13) and (LocalBuf <> '') then
                begin
                     S := LocalBuf;
                     LocalBuf := '';
                     ClearInput;
                     HandleInput(S);
                     RedrawInput;
                end else
                if (Ch in [#8, #32..#126]) then
                begin
                     if (Ch = #8) then
                     begin
                          if (LocalBuf = '') then
                             Ch := #0
                          else
                          begin
                               Delete(LocalBuf, Length(LocalBuf), 1);
                               mWrite(#8#32);
                          end;
                     end else
                     if (Length(LocalBuf) < 200) then
                        LocalBuf := LocalBuf + Ch;

                     if (Length('[' + ChanList[CurChan] + '] ' + LocalBuf) >= 79) then
                        RedrawInput
                     else
                     if (Ch <> #0) then
                        mWrite(Ch);
                end;
           end;
     until (DoQuit);
end;

procedure StartIOThread;
begin
     VPBeginThread(IOThread, 16384, nil);
end;

initialization
begin
     LocalBuf := '';
     RemoteBuf := '';
     GetMem(PC, 4096);
end;

finalization
begin
     FreeMem(PC);
end;

end.
